#!/usr/bin/env python

"""
Creates a template subject, i.e. the folder structure and the create_subject.py file.

create_new_subject.py -f <path>

-f ... path of new subject
"""
import os
import warnings
import argparse
import subprocess

parser = argparse.ArgumentParser(description='Creates a new subject in path')
parser.add_argument('-f', '--fn_subject', help='path of new subject', required=True)
args = parser.parse_args()

fn_subject = os.path.abspath(args.fn_subject)
subject_id = os.path.split(fn_subject)[1]

if os.path.exists(fn_subject):
    print("Subject already exists... aborting")
    exit()

os.makedirs(fn_subject)
os.makedirs(os.path.join(fn_subject, "exp"))
os.makedirs(os.path.join(fn_subject, "mesh"))
os.makedirs(os.path.join(fn_subject, "opt"))
os.makedirs(os.path.join(fn_subject, "mri", "0", "original", "dicom"))
os.makedirs(os.path.join(fn_subject, "mri", "0", "original", "nifti", "t1"))
os.makedirs(os.path.join(fn_subject, "mri", "0", "original", "nifti", "t2"))
os.makedirs(os.path.join(fn_subject, "mri", "0", "original", "nifti", "dti"))
os.makedirs(os.path.join(fn_subject, "results"))

f = open(os.path.join(fn_subject, f"create_{subject_id}.py"), "w")
f.write("#!/usr/bin/env python\n")
f.write("import os\n")
f.write("import pynibs\n")
f.write("import numpy as np\n")
f.write("from inspect import getsourcefile\n")
f.write("\n")
f.write("subject_folder = os.path.split(os.path.abspath(getsourcefile(lambda: 0)))[0]\n")
f.write("\n")
f.write("# subject information\n")
f.write("###############################################################"
        "#########################################################\n")
f.write("subject_id = '{}'\n".format(subject_id))
f.write("fn_subject_obj = subject_folder + f'{os.sep}{subject_id}.hdf5'\n")
f.write("\n")
f.write("# MRI information\n")
f.write("###############################################################"
        "#########################################################\n")
f.write("mri = [dict()]\n")
f.write("mri[0]['fn_mri_T1'] = subject_folder + f'{os.sep}mri{os.sep}0{os.sep}original{os.sep}nifti{os.sep}t1{os.sep}T1.nii'\n")
f.write("mri[0]['fn_mri_T2'] = subject_folder + f'{os.sep}mri{os.sep}0{os.sep}original{os.sep}nifti{os.sep}t2{os.sep}T2.nii'\n")
f.write("mri[0]['fn_mri_DTI'] = subject_folder + f'{os.sep}mri{os.sep}0{os.sep}original{os.sep}nifti{os.sep}dti{os.sep}DTI.nii'\n")
f.write("mri[0]['fn_mri_DTI_rev'] = subject_folder + f'{os.sep}mri{os.sep}0{os.sep}original{os.sep}nifti{os.sep}dti{os.sep}DTI_rev.nii'\n")
f.write("mri[0]['fn_mri_DTI_bvec'] = subject_folder + f'{os.sep}mri{os.sep}0{os.sep}original{os.sep}nifti{os.sep}dti{os.sep}DTI.bvec'\n")
f.write("mri[0]['fn_mri_DTI_bval'] = subject_folder + f'{os.sep}mri{os.sep}0{os.sep}original{os.sep}nifti{os.sep}dti{os.sep}DTI.bval'\n")
f.write("mri[0]['dti_readout_time'] = '0.0476258'\n")
f.write("mri[0]['dti_phase_direction'] = '-y'\n")
f.write("mri[0]['freesurfer_dir'] = subject_folder + '/mri/0/original/fs'\n")
f.write("mri[0]['dti_tensor_fn'] = None  # if you want to provide your own, preprocessed tensor file, set it here\n")
f.write("\n")
f.write("# Mesh information\n")
f.write("################################################################"
        "########################################################\n")
f.write("mesh = dict()\n")
f.write("# Add one dict() for each mesh. See templates below.\n")
f.write("mesh['charm_4.1_refined_M1_fs'] = dict()\n")
f.write("mesh['charm_4.1_refined_M1_fs']['info'] = 'charm_4.1_refined_M1_fs'\n")
f.write("mesh['charm_4.1_refined_M1_fs']['approach'] = 'charm'\n")
f.write("mesh['charm_4.1_refined_M1_fs']['mesh_folder'] = os.path.join(subject_folder, 'mesh', 'charm_4.1_refined_M1_fs')\n")
f.write("mesh['charm_4.1_refined_M1_fs']['vertex_density'] = None\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_mesh_msh'] = os.path.join(mesh['charm_4.1_refined_M1_fs']['mesh_folder'],  f'm2m_{subject_id}', f'{subject_id}.msh')\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_mesh_hdf5'] = os.path.join(mesh['charm_4.1_refined_M1_fs']['mesh_folder'], f'm2m_{subject_id}', f'{subject_id}.hdf5')\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_tensor_vn'] = f'm2m_{subject_id}/DTI_coregT1_tensor.nii.gz'\n")
f.write("mesh['charm_4.1_refined_M1_fs']['mri_idx'] = 0\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_mri_conform'] = f'm2m_{subject_id}/T1.nii.gz'\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_lh_wm'] = None\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_rh_wm'] = None\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_lh_gm'] = None\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_rh_gm'] = None\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_lh_gm_curv'] = None\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_rh_gm_curv'] = None\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_lh_midlayer'] = f'm2m_{subject_id}/surfaces/lh.central.gii'\n")
f.write("mesh['charm_4.1_refined_M1_fs']['fn_rh_midlayer'] = f'm2m_{subject_id}/surfaces/rh.central.gii'\n")
f.write("mesh['charm_4.1_refined_M1_fs']['smooth_skin'] = .8\n")
f.write("mesh['charm_4.1_refined_M1_fs']['refinement_roi'] = 'midlayer_m1s1pmd'\n")
f.write("mesh['charm_4.1_refined_M1_fs']['refinemement_element_size'] = 0.75\n")
f.write("mesh['charm_4.1_refined_M1_fs']['use_fs'] = True  # use freesurfer segmentation to improve head mesh\n")

f.write("\n")

f.write("# ROI information (first index: mesh, second index: roi)\n")
f.write("################################################################"
        "########################################################\n")
f.write("roi = dict()\n")
f.write("# Add one dict() for each roi per mesh. See templates below.\n")
f.write("\n")
f.write("roi['charm_4.1_refined_M1_fs'] = dict()\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd'] = dict()\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['type'] = 'surface'\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['info'] = 'freesurfer PMd, M1 and somatosensory cortex'\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['gm_surf_fname'] = mesh['charm_4.1_refined_M1_fs']['fn_lh_gm']\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['wm_surf_fname'] = mesh['charm_4.1_refined_M1_fs']['fn_lh_wm']\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['midlayer_surf_fname'] = mesh['charm_4.1_refined_M1_fs']['fn_lh_midlayer']\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['refine'] = False\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['delta'] = 0.5\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['X_ROI'] = None\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['Y_ROI'] = None\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['Z_ROI'] = None\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['layer'] = 3\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['fn_mask'] = f'roi/midlayer_m1s1pmd/mask_{subject_id}m1pmdss.mgh'\n")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['fn_mask_avg'] = 'tmsloc_proto/examppes/lefthandknob_M1S1PMd.overlay'\n")
warnings.warn("Adjust the fn_mask_avg path to your needs")
f.write("roi['charm_4.1_refined_M1_fs']['midlayer_m1s1pmd']['hemisphere'] = 'lh'\n")

f.write("\n")

f.write("# Experiment information\n")
f.write("###############################################################"
        "#########################################################\n")
f.write("exp = dict()\n")
f.write("# Add one dict() for each experiment. See templates below.\n")
f.write("\n")
f.write("# exp['TMS_Localite_template'] = dict()\n")
f.write("# exp['TMS_Localite_template']['info'] = ['TMS-MEP template Localite (MPI)']\n")
f.write("# exp['TMS_Localite_template']['date'] = ['XX{os.sep}XX{os.sep}20XX']\n")
f.write("# exp['TMS_Localite_template']['nnav_system'] = 'Localite'\n")
f.write("# exp['TMS_Localite_template']['fn_tms_nav'] = [[subject_folder + '...xml', subject_folder + '...xml']]\n")
f.write("# exp['TMS_Localite_template']['fn_data'] = [[subject_folder + '{os.sep}exp{os.sep}0{os.sep}mep{os.sep}...cfs']]\n")
f.write("# exp['TMS_Localite_template']['fn_intensity'] = None\n")
f.write("# exp['TMS_Localite_template']['mep_onsets'] = [[0]]\n")
f.write("# exp['TMS_Localite_template']['fn_exp_csv'] = [subject_folder + '{os.sep}exp{os.sep}0{os.sep}experiment.csv']\n")
f.write("# exp['TMS_Localite_template']['fn_exp_hdf5'] = [subject_folder + '{os.sep}exp{os.sep}0{os.sep}experiment.hdf5']\n")
f.write("# exp['TMS_Localite_template']['fn_coil'] = [['...{os.sep}MagStim_Alpha_Coil_70mm_Fig8.nii.gz']]\n")
f.write("# exp['TMS_Localite_template']['fn_mri_nii'] = [[subject_folder + '{os.sep}exp{os.sep}0{os.sep}..._conform.nii']]\n")
f.write("# exp['TMS_Localite_template']['cond'] = [['']]\n")
f.write("# exp['TMS_Localite_template']['channels'] = [['FDI', 'ADM', 'APB']]")
f.write("# exp['TMS_Localite_template']['tms_pulse_time'] = None\n")
f.write("# exp['TMS_Localite_template']['experimenter'] = ''\n")
f.write("# exp['TMS_Localite_template']['mep_fit_info'] = ['']\n")
f.write("# exp['TMS_Localite_template']['incidents'] = ['']\n")
f.write("# exp['TMS_Localite_template']['postproc'] = [dict()]\n")
f.write("# exp['TMS_Localite_template']['postproc'][0]['info'] = ' '\n")
f.write("# exp['TMS_Localite_template']['postproc'][0]['cmd'] = ' '\n")
f.write("\n")
f.write("# exp['TMS_ANT_template'] = dict()\n")
f.write("# exp['TMS_ANT_template']['info'] = ['TMS-MEP-EEG template (ANT)']\n")
f.write("# exp['TMS_ANT_template']['date'] = ['XX{os.sep}XX{os.sep}20XX']\n")
f.write("# exp['TMS_ANT_template']['nnav_system'] = 'Visor'\n")
f.write("# exp['TMS_ANT_template']['fn_data'] = [[subject_folder + '{os.sep}exp{os.sep}2{os.sep}...cnt']]\n")
f.write("# exp['TMS_ANT_template']['fn_exp_hdf5'] = [subject_folder + '{os.sep}exp{os.sep}2{os.sep}experiment.hdf5']\n")
f.write("# exp['TMS_ANT_template']['fn_coil'] = [['...{os.sep}MagStim_Alpha_Coil_70mm_Fig8.nii.gz']]\n")
f.write("# exp['TMS_ANT_template']['fn_mri_nii'] = [[subject_folder + '{os.sep}exp{os.sep}2{os.sep}..._conform.nii']]\n")
f.write("# exp['TMS_ANT_template']['fn_visor_cnt'] = [subject_folder + '{os.sep}exp{os.sep}2{os.sep}...pos.cnt']\n")
f.write("# exp['TMS_ANT_template']['fn_visor_calibration'] = [subject_folder + '{os.sep}exp{os.sep}2{os.sep}...calibration.xml']\n")
f.write("# exp['TMS_ANT_template']['fn_eeg_cnt'] = [subject_folder + '{os.sep}exp{os.sep}2{os.sep}eeg{os.sep}...cnt']\n")
f.write("# exp['TMS_ANT_template']['eeg_channels'] = ['all']\n")
f.write("# exp['TMS_ANT_template']['fn_emg_cnt'] = [subject_folder + '{os.sep}exp{os.sep}2{os.sep}emg{os.sep}...cnt']\n")
f.write("# exp['TMS_ANT_template']['emg_channels'] = [0]\n")
f.write("# exp['TMS_ANT_template']['emg_max_duration'] = [10]\n")
f.write("# exp['TMS_ANT_template']['eeg_max_duration'] = [10]\n")
f.write("# exp['TMS_ANT_template']['emg_trigger_value'] = ['4']\n")
f.write("# exp['TMS_ANT_template']['eeg_trigger_value'] = ['1']\n")
f.write("# exp['TMS_ANT_template']['cond'] = [['M1_random']]\n")
f.write("# exp['TMS_ANT_template']['tms_pulse_time'] = None\n")
f.write("# exp['TMS_ANT_template']['experimenter'] = ' '\n")
f.write("# exp['TMS_ANT_template']['mep_fit_info'] = [' ']\n")
f.write("# exp['TMS_ANT_template']['incidents'] = [' ']\n")
f.write("# exp['TMS_ANT_template']['fiducal_corr'] = [[0,0,0]]  # x,y,z in mm\n")
f.write("\n")
f.write("# save subject information in .hdf5 file\n")
f.write("###############################################################"
        "#########################################################\n")
f.write("pynibs.save_subject_hdf5(fname=fn_subject_obj,\n")
f.write("                          mri_dict=mri,\n")
f.write("                          mesh_dict=mesh,\n")
f.write("                          roi_dict=roi,\n")
f.write("                          exp_dict=exp,\n")
f.write("                          ps_dict=None,\n")
f.write("                          subject_id=subject_id,\n")
f.write("                          subject_folder=subject_folder)\n")
f.write("\n")
f.write("print(f'Created subject .hdf5 file: {fn_subject_obj}')\n")
f.close()

fn = os.path.join(fn_subject, f'create_{subject_id}.py')
print(f"Created subject info file: {fn}\n. Edit this file to your needs and rerun 'python {fn}")
subprocess.Popen(f"python {fn}", shell=True)

